#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
from PyQt4 import QtGui, QtCore

class TestWidget(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        self.setGeometry(300, 300, 250, 150)
        self.setStyleSheet("background:red;")
        self.test_button = QtGui.QPushButton('Embed widget', self)
        self.test_button.setGeometry(10, 10, 200, 35)
        self.test_button1 = QtGui.QPushButton('Change widget', self)
        self.test_button1.setGeometry(10, 60, 200, 35)
        self.connect(self.test_button, QtCore.SIGNAL('clicked()'),self.onClick)
        self.connect(self.test_button1, QtCore.SIGNAL('clicked()'),self.onClick1)
      
    def onClick1(self):
      print 'change widget from TestWidget'
      self.parent().setCentralWidget(AnotherWidget())
    
    def onClick(self):
        print 'change central widget to embed container'
        self.parent().setCentralWidget(EmbedWidget())
 
      
class AnotherWidget(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        self.setGeometry(300, 300, 250, 150)
        self.setStyleSheet("background:yellow;")
        self.test_button = QtGui.QPushButton('back', self)
        self.test_button.setGeometry(10, 10, 200, 35)
        self.connect(self.test_button, QtCore.SIGNAL('clicked()'),self.onClick)
     
    def onClick(self):
      print 'change widget from AnotherWidget'
      w=TestWidget()
      self.parent().setCentralWidget(w)

class EmbedWidget(QtGui.QX11EmbedContainer):
    def __init__(self, parent=None):
        super(EmbedWidget,self).__init__(parent)
        self.setGeometry(300, 300, 250, 150)
        self.setStyleSheet("background:green;")
        self.connect(self, QtCore.SIGNAL("clientClosed()"), self.onClose)
        self.connect(self, QtCore.SIGNAL("clientIsEmbedded()"), self.isLoaded)	        
        self.mytimer=QtCore.QTimer()
        self.connect(self.mytimer, QtCore.SIGNAL('timeout()'),self.startProc)
        self.mytimer.start(0)
        self.qp=QtCore.QProcess()
    
    def startProc(self):
        self.mytimer.stop()
        wid=self.winId()
        cmd='python embedded.py '+str(wid)
        print cmd
        self.qp.start(cmd)
        #self.embedClient(60817410)
    
    def onClose(self):
        print 'embedded widget closed'
        print self.qp.readAllStandardOutput()
        self.qp.close()
        self.qp.kill()
        w=TestWidget()
        self.parent().setCentralWidget(w)
    
    def isLoaded(self):
        print 'loaded'
        self.setFocus()

class MainApp(QtGui.QMainWindow):
  def __init__(self, parent=None):
        QtGui.QMainWindow.__init__(self, parent)
        self.setGeometry(300, 300, 250, 150)
        self.setWindowTitle('QX11Embed demo')
        t=TestWidget()
        self.setCentralWidget(t)

app = QtGui.QApplication(sys.argv)
m = MainApp()
m.show()
sys.exit(app.exec_())

